<template>
  <div class="contSec">
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css"
      integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2"
      crossorigin="anonymous"
    />
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Asignaciones Especiales</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>Asigna una visita Especial</strong>
        <div class="supSec">
          Trimestre: {{ getTrimestres() }} / Año: {{ anio.getFullYear() }}
        </div>
      </div>
    </div>
    <!-- termina Encabezado -->
    <!-- Inicia Contenido -->
    <div class="contSecc">
      <div class="titSecCard">Búsqueda</div>
      <v-card style="background-color: #fafafa;">
        <v-container fluid>
          <div class="indicaciones">
            Coloca los datos del visitante y de la sucursal a visitar.
          </div>
          <!-- 
              v-model="cecoSeleccionado.ceco" nombre del vue model
             :items="metadata.cecos" mi metadata o arreglo
              @keyup="actualizaCecos" evento que desencadena
              item-value="ceco" nombre de campo que viene en el json
              item-text="ceco" nombre del campo que viene en el json 
              return-object  retorna todo el objeto
              :search-input.sync="textoIngresado" busca en el texto ingresado
               :rules="[() => !!cecoSeleccionado || 'Debes seleccionar un ceco']" reglas 
              outlined el tipo de coponente redondo o unlined es una linea
              -->
          <!-- Todo va en un v-row que esta todo junto-->
          <v-row align="center">
            <!-- tipo visita -->
            <v-col cols="4">
              <div class="titCampos">
                Tipo Visita
                <v-select
                  ref="negocioValue"
                  v-model="listaTipoNego"
                  :items="metadata.negocios"
                  item-value="acronimo"
                  item-text="descripcion"
                  placeholder="Punto de Venta"
                  dense
                  hide-no-data
                  clearable
                  outlined
                  @click="getNegocios"
                  append-icon
                  return-object
                >
                </v-select>
              </div>
            </v-col>
            <!-- CECO / SUCURSAL-->
            <v-col cols="4">
              <div class="titCampos">Sucursal</div>
              <v-autocomplete
                outlined
                ref="cecoValue"
                v-model="cecoSeleccionado"
                :items="metadata.cecos"
                item-value="ceco"
                item-text="ceco"
                dense
                clearable
                :disabled="habilitaSuc"
                hide-no-data
                placeholder="Busca una sucursal"
                append-icon
                :search-input.sync="textoIngresado"
                :rules="[
                  () => !!cecoSeleccionado || 'Debes seleccionar un ceco',
                ]"
                @keyup="actualizaCecos"
                return-object
                :cache-items="false"
                class="custom-autocomplite"
              >
              </v-autocomplete>
            </v-col>

            <!-- visitante -->

            <v-col cols="4">
              <div class="titCampos">Visitante</div>
              <v-autocomplete
                outlined
                no-filter
                ref="usuarioValue"
                v-model="usuarioEncontrado"
                :items="metadata.usuarios"
                item-value="idUsuario"
                item-text="nombreUsuario"
                dense
                clearable
                hide-no-data
                placeholder="Escribe el nombre o número de empleado"
                :search-input.sync="textoUsuarioIngresado"
                :rules="[!!usuarioEncontrado || 'Debes Seleccionar un usuario']"
                @keyup="actualizaUsuarios"
                append-icon
                return-object
                :cache-items="false"
              >
              </v-autocomplete>
            </v-col>

            <!-- Boton Guardar -->
            <v-col cols="5"></v-col>
            <v-btn
              color="primary"
              dark
              @click="altaAsignacion()"
              :disabled="bloquear"
            >
              <strong style="fond-size : 16px; color:  #000;">Guardar</strong>
            </v-btn>
          </v-row>
        </v-container>
      </v-card>
      <div class="titSec">Visitas Asignadas</div>
      <v-card>
        <tabla-asignacion ref="tabla"></tabla-asignacion>
      </v-card>
    </div>
    <v-dialog v-model="dialog" max-width="600" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <strong>¡Asignacion Especial Exitosa!</strong>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>
            La asignación ha sido exitosa. Podrás visualizar dichas asignaciones
            en la tabla de <strong>Visitas Asignadas.</strong> <br />
          </div>
          <div class="btnCenter">
            <v-btn color="primary" dark @click="dialog = false">
              <strong style="fond-size : 16px; color:  #000;"
                >De acuerdo</strong
              >
            </v-btn>
          </div>
        </div>
      </v-card>
    </v-dialog>

    <v-dialog v-model="dialogFallo" max-width="600" persistent>
      <v-card class="padding">
        <v-card-title class="headline">
          <div class="titModal">
            <div><strong>Algo paso al dar de alta Asignacion</strong></div>
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <div>
            La visita especial fallo, Te falto llenar un campo
          </div>
        </div>
        <div class="btnCenter">
          <v-btn color="primary" dark @click="dialogFallo = false">
            <strong style="fond-size : 16px; color:  #000;"
              >¿Reintentar?</strong
            >
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import axios from "axios";
const axiosAPILocal = store.state.axiosApiLocal;
import store from "@/store";
import TablaAsignacion from "@/views/secure/modelo-franquicia/components/TablaAsignacion";

export default {
  name: "modelo_franquicia_asignacion_especial",
  components: {
    TablaAsignacion,
  },
  data() {
    return {
      quarter: "",
      trimestres: [
         { trimestre: "Enero-Marzo", id: 0 },
        { trimestre: "Enero-Marzo", id: 1 },
        {
          trimestre: "Abril-Junio",
          id: 2,
        },
        {
          trimestre: "Julio-Septiembre",
          id: 3,
        },
        {
          trimestre: "Octubre-Diciembre",
          id: 4,
        },
      ],
      d: new Date(),
      anio: new Date(),
      activeButton: false,
      objAdd: "",
      prefijo: null,
      nombre: null,
      ceco: null,
      id_usuario: null,
      nombreUsuario: null,
      idPuesto: null,
      //Dialogs
      dialog: false,
      dialogFallo: false,
      cecoIngresado: "",
      cecoSeleccionado: "",
      cecosEncontrados: [],
      usuarioEncontrado: "",
      textoUsuarioIngresado: "",
      textoIngresado: "",
      listaTipoNego: "",
      habilitaSuc: true,
      gerenteEncontrado: "",
      cards: [
        {
          title: "Director Asignacion",
          src: require("@/assets/img/alta-protocolo-aseguramiento-b.svg"),
          description: "",
          to: {
            name: "modelo_franquicia_protocolos",
            params: {
              tipo_protocolo: "aseguramiento-calidad",
            },
          },
          color: "#808080",
        },
      ],
      metadata: {
        cecos: [],
        usuarios: [],
        negocios: [],
        gerentes: [],
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Asignaciones",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_asignaciones_home_asignacion",
          },
        },
        {
          text: "Asignacion Especial",
          disabled: true,
        },
      ],
    };
  },
  created() {
    // this.getNegocios();
  },
  methods: {
    //cecos
    getCecos() {
      axios
        .post("negoVers/secure/post/cecos", {
          prefijo: this.prefijo,
          idCeco: this.ceco,
          nombreCeco: this.nombre,
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.metadata.cecos = [];

              console.log(JSON.stringify(response.data));

              for (var i = 0; i < response.data.data.length; i++) {
                this.metadata.cecos.push({
                  ceco:
                    response.data.data[i].nombreCeco +
                    " - " +
                    response.data.data[i].idCeco,
                  idCeco: response.data.data[i].idCeco,
                });
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    actualizaCecos() {
      if (
        this.textoIngresado != null &&
        this.textoIngresado.length > 3 &&
        this.negocioSelecionado.idNegocio == 1
      ) {
        this.prefijo = 92;
        this.ceco = null;
        this.nombre = this.textoIngresado;
        this.muestraGeo = true;
        this.getCecos();
      } else if (
        this.textoIngresado != null &&
        this.textoIngresado.length > 3 &&
        this.negocioSelecionado.idNegocio == 5
      ) {
        this.prefijo = 23;
        this.ceco = null;
        this.nombre = this.textoIngresado;
        this.muestraGeo = true;
        this.getCecos();
      } else if (
        this.textoIngresado != null &&
        this.textoIngresado.length > 3 &&
        (this.negocioSelecionado.idNegocio == 8 ||
          this.negocioSelecionado.idNegocio == 7)
      ) {
        this.prefijo = 55;
        this.ceco = null;
        this.nombre = this.textoIngresado;
        this.muestraGeo = true;
        this.getCecos();
      } else {
        this.metadata.cecos = [];
      }
    },

    //FIN CECO
    /* INICIA USUARIOS */
    getUsuarios() {
      axios
        .post("/negoVers/secure/post/usuarios", {
          id_usuario: this.idUsuario,
          nombreUsuario: this.nombreUsuario,
          idPuesto: this.idPuesto,
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.usuarios = response.data.data;

                //console.log(JSON.stringify(this.metadata.usuarios))
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },

    getUsuariosAPILocal() {
      this.isLoading = true;
      var self = this;
      let options = {
        usuario: this.textoUsuarioIngresado,
      };
      axiosAPILocal
        .post("/usuarios-negocio/v1/busquedas", options)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.metadata.usuarios = [];
            let usuarios = [];

            data.resultado.usuarios.forEach((element) => {
              let usuario = {
                idUsuario: element.numeroEmpleado,
                nombreUsuario: element.numeroEmpleado + " - " + element.nombre,
                idPuesto: 0,
              };
              usuarios.push(usuario);
            });

            this.metadata.usuarios = usuarios;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.isLoading = false;
        });
    },
    actualizaUsuarios() {
      if (
        this.textoUsuarioIngresado != null &&
        this.textoUsuarioIngresado.length > 3
      ) {
        this.getUsuariosAPILocal();
      } else {
        this.metadata.usuarios = [];
      }
    },
    /* FIN USUARIOS
     */

    //OBTIENEN negocios
    getNegocios() {
      axios
        .post("/negoVers/secure/post/negocio", {
          idNegocio: null,
        })
        .then((response) => {
          //console.log(JSON.stringify(response.data.data))
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.negocios = response.data.data;
                this.metadata.cecos = [];
                this.habilitaSuc = false;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    //ALTA ASIGNACION
    altaAsignacion() {
      this.objAdd = {
        idUsuario: this.usuarioEncontrado.idUsuario,
        idCeco: this.cecoSeleccionado.idCeco,
        nombreCeco: this.cecoSeleccionado.nombreCeco,
        idPerfil: 3,
        idNegocio: this.negocioSelecionado.idNegocio,
        idGerente: this.gerenteEncontrado.idUsuario,
        territorio: this.territorio,
        zona: this.zona,
      };
      axios
        .post("asignacion-sup/secure/post/alta/asignacion", this.objAdd)
        .then((response) => {
          if (
            this.objAdd.idUsuario != "" &&
            this.objAdd.idCeco != "" &&
            this.objAdd.idNegocio != ""
          ) {
            //alert("entro"+JSON.stringify(this.objAdd));
            // console.log(response)
            if (response) {
              if (response.status == 200) {
                if (response.data.data == 1) this.dialog = true;
                //manda llamar el metodo que actualiza la tabla
                this.update();
              } else {
                //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
                this.dialogFallo = true;
              }
            }
          } else {
            //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
            this.dialogFallo = true;
            this.usuarioEncontrado = "";
            this.cecoSeleccionado = "";
            this.listaTipoNego = "";
            this.metadata.cecos = [];
            this.metadata.usuarios = [];
            this.$refs.cecoValue.resetValidation();
            this.$refs.usuarioValue.resetValidation();
            this.habilitaSuc = true;
          }
          this.usuarioEncontrado = "";
          this.cecoSeleccionado = "";
          this.listaTipoNego = "";
          this.metadata.cecos = [];
          this.metadata.usuarios = [];
          this.$refs.cecoValue.resetValidation();
          this.$refs.usuarioValue.resetValidation();
          this.habilitaSuc = true;
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    validateForm() {
      if (
        this.usuarioEncontrado.idUsuario === "" ||
        this.cecoSeleccionado.idCeco === "" ||
        this.listaTipoNego.idNegocio === ""
      ) {
        this.activeButton = false;
      } else {
        this.activeButton = true;
      }
    },
    getTrimestres() {
      this.quarter = Math.ceil(this.d.getMonth() / 3);
      if (this.quarter === this.trimestres[this.quarter].id) {
        return this.trimestres[this.quarter].trimestre;
      }
    },
    update() {
      //console.log("entro a metodo")
      //con $refs se ocupa para acceder a la tabla de otro componente y mandar llamar sus metodos
      this.$refs.tabla.getAsignaciones();
    },
  },
  computed: {
    bloquear() {
      return this.cecoSeleccionado === "" &&
        this.usuarioEncontrado === "" &&
        this.listaTipoNego === ""
        ? true
        : false;
      //return  this.cecoSeleccionado===""? true: false
    },
  },
};
</script>
<style>
.padding {
  padding: 25px;
}
</style>
